//VIDEO OUT 32x16dot
//for ATtiny2313 (ext. clock 20MHz)

//by takuya matsubara
//http://nicotak.com

// 9600bpsŎMrbg}bvTV out

//Ђ傢̋ZpgĂ܂
// http://www7.big.jp/~kerokero/avr/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>

//--------------------------------------
#define BYTE unsigned char
#define WORD unsigned short
#define DWORD unsigned long

#include "text.h"


//---------------------------------------------------------------------
//   h^ns`
//---------------------------------------------------------------------

struct PB{
	char :1;			//0
	char :1;			//1
	char VID_DOT:1;		//2 rfIEhbg
	char VID_SYNC:1;	//3 rfIMoc1a
	char BEEP:1;		//4 TEhooc1b
	char :1;			//5
	char :1;			//6
	char :1;			//7
};

#define pib (*(volatile struct PB*)&PINB)
#define pdb (*(volatile struct PB*)&DDRB)
#define pob (*(volatile struct PB*)&PORTB)

//--------------------------------------

//NbNXs[hmenuProject - ConfigrationŐݒς
#ifndef F_CPU
	#define F_CPU 20000000	// CPUNbNg[Hz]
#endif
#define FREQ_H 15750	// horizontal frequency[Hz]



///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////// rfIM
///////////////////////////////////////////////////////////////////////////

BYTE linesync=1;
BYTE linetmp=0;
BYTE linetmp2=0;
BYTE row=0;
volatile BYTE tick=0;

#define OFFSETH 32		//][line]
#define OFFSETV 230		//s̗][clock]
#define DOTH 12			//1pixel̃TCY[line]

unsigned long vram[16];

///////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////// 荞ݏ
// 1sec/15750Hz =  63.49...usec
// (1sec/60) / (1sec/15750) = 262.5

//   1`9:M
//       1`3OupX
//       4`6pX
//       7`9upX
//   10`21:eXgMȂ

void video_driver(void)
{
	if(linesync <= OFFSETH){	// line001-line021 
		if(linesync == 1){	//(line001-line006)
			//Output Compare Register A
			OCR1A = ((F_CPU / FREQ_H) - 20);
		}else if(linesync == 7){
			OCR1A = F_CPU / 160000; //
		}
		linesync++;
		return;
	}
	//line022-

	linetmp++;

	if(row >= VRAMHEIGHT){

		if(linetmp == ((VRAMHEIGHT * DOTH)+1)){
			tick++;
			return;
		}
		if(linetmp == (262-OFFSETH)){
			linesync = 1;
			linetmp = 0;
			linetmp2=0;
			row=0;
		}
		return;
	}

//	linetmp2++;
//	if(linetmp2 >= DOTH){
//		row++;
//		linetmp2=0;
//		return;
//	}

	DWORD temp;

	temp = vram[row];

	while(TCNT1L < OFFSETV);	//// Ԓ ////

	char bitcnt = VRAMWIDTH;
	while(bitcnt--){
		pob.VID_DOT = ((temp & 0x80000000)!=0);
		asm("nop\n");
		asm("nop\n");
		asm("nop\n");
		asm("nop\n");
		asm("nop\n");
		asm("nop\n");
		asm("nop\n");
		temp <<=1;
	}
	pob.VID_DOT = 0;
	linetmp2++;
	if(linetmp2 >= DOTH){
		row++;
		linetmp2=0;
		return;
	}

	return;
}


////////////////////////////////////////////////////
/////////////////////////// 
////////////////////////////////////////////////////

void video_init(void)
{
	/// PWMݒ ///
	TCNT1 = 0;
	ICR1 = (F_CPU / FREQ_H) - 1;	/// TOPl

	TCCR1A = (3<<COM1A0)|(2<<COM1B0)|(2<<WGM10);//fast pwm
	TCCR1B = (3<<WGM12)|(1<<CS10);

//Waveform Generation Mode WGM1x = 0b1110
//clock select= clk div1

	/// 
	TIMSK |= (1<<TOIE1);	// ^C}[Pꊄ

	/// |[go
	pdb.VID_DOT  = 1;
	pdb.VID_SYNC = 1;
	pdb.BEEP = 1;
}

/////////////////////////////////////////////////////

//-----------------------^C}荞
SIGNAL(SIG_OVERFLOW1)
{	//	15750Hz
	video_driver();
}

void vram_dummy(void)
{
	vram_line(0,0,VRAMWIDTH-1,15,1);
	vram_line(VRAMWIDTH-1,0,0,15,1);
}


//--------------------------
void idle(void){
	
	sleep_mode();		// 
}

//--------------------------
void sleep_loop(void)
{
	BYTE tickback;

	tickback = tick;

    set_sleep_mode(SLEEP_MODE_IDLE); //

	while(tickback == tick){
		idle();// 1/60sec
	}
	tickback=tick;
}
#define BAUDRATE 9600 // bps
#define MYUBRR ((F_CPU/16/BAUDRATE)-1) // UART

// USARTݒ
void sio_init(void)
{
	UBRRH = (MYUBRR >> 8); // {[[g
	UBRRL = MYUBRR & 0xff; // {[[g

	UCSRB = (1<<RXEN)|(1<<TXEN);

	//set frame format data8, stop1, nonparity
	UCSRC=(1<<UCSZ1) | (1<<UCSZ0);

	DDRD  &= ~(1<<0);	//input rx
	PORTD |=  (1<<0);	//pull up rx
}

char seq = -1;

unsigned char sio_rx(void)
{
	int timeout=0;

	while((UCSRA & (1<<RXC))==0){
		sleep_mode();		// 
		timeout++;
		if(timeout > 10000){
			seq = -1;
			break;
		}
	};

	return(UDR);
}

SIGNAL(SIG_INTERRUPT0)
{
	// power on
	GIMSK &= ~(1<<INT0);   // INT0(Lowxo)荞disable
}

//extern ST_SND sndwrk[SNDTRKMAX];

//-------------------------------------------------------
int main(void)
{
	unsigned char *p;

	video_init();	// initialize H-sync intr.
	vram_dummy();
	sio_init();

	sei();
	while(1)
	{
		if(seq==-1){
			if(sio_rx()==0x41){
				seq=0;
				p = (unsigned char *)vram;
			}
		}else{
			*p++ = sio_rx();
			seq++;
			if(seq >= 64){
				seq = -1;
			}
		}
/*
		if(sio_rx()==0x40){
			for(y=0;y<16;y++){
				c = sio_rx();
				for(i=0; i<8; i++){
					vram_pset(i,y,((0x80 & c)!=0));
					c <<= 1;
				}
				c = sio_rx();
				for(i=0; i<8; i++){
					vram_pset(i+8,y,((0x80 & c)!=0));
					c <<= 1;
				}
			}
		}
*/
	}
	return 0;
}
